// This program demonstrates different ways of formatting and printing
// output. 

public class PrintingDemo {

    public static void main(String[] args) {

        // a basic print statement
        System.out.println("Hello, world!");

        System.out.println("Hello" + "," + " " + "world" + "!");

        System.out.println("pi squared is " + Math.PI * Math.PI);
        System.out.println("pi squared is " + Math.pow(Math.PI, 2));
        System.out.println("pi doubled is");
        System.out.println(Math.PI + Math.PI);
        System.out.println("pi doubled is " + Math.PI + Math.PI); // HUH?

        // prints a blank line
        System.out.println();

        // prints everything on the same line
        System.out.print("pi ");
        System.out.print("squared ");
        System.out.print("is ");
        System.out.println(Math.PI * Math.PI);

        // special characters
        System.out.println("Line one\nLine two\nLine three with \"embedded\" quotes");

        // formatted printing with printf
        String greeting = "Hello";
        System.out.printf("%s, world!\n", greeting);

        int threeSquared = 3 * 3;
        System.out.printf("3 squared is %d\n", threeSquared);

        double piSquared = Math.pow(Math.PI, 2);
        System.out.printf("pi squared is %.4f\n", piSquared);

        double price = 15.6666667;
        System.out.printf("The price is $%.2f\n", price);

        // String.format constructs a formatted string
        String day = "Thursday";
        String date = String.format("%s, %s %d, %d", day, "July", 4, 1776);
        System.out.println(date);

        System.out.println("Three divided by two is");
        System.out.println(3 / 2);    // gives 1, not 1.5
        System.out.println(3 / 2.0);  // gives 1.5
    }
}
